"use strict";

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * Config options
 * @typedef {Object.<string, *>} Config
 * @property {string} [method = "GET"] - HTTP request method
 * @property {string} [url] - The url
 * @property {Object.<string, string>} [headers = {}] - The request headers
 * @property {Object.<string, *>} [params] - The request query
 * @property {*} [data = null] - The data to be sent
 * @property {number} [maxRedirects = 5] - Maximum redirects before error is thrown
 * @property {boolean} [withCredentials = false] - Whether cross-site Access-Control requests should be made using credentials
 *
 * Regrest response object
 * @typedef {Object.<string, *>} Response
 * @property {number} status - The response status code
 * @property {string} statusText - The response status text
 * @property {Object.<string, string>} headers - The response headers
 * @property {string} text - The response raw text
 * @property {Object} json - The response parsed as JSON
 */
var ENVIRONMENTS = Object.freeze({
  BROWSER: 0,
  NODE: 1,
  UNKNOWN: 2
}); // Detect whether instance is ran in browser or on node js

var ENV = (typeof window === "undefined" ? "undefined" : _typeof(window)) === "object" && _typeof(window.document) === "object" ? ENVIRONMENTS.BROWSER : (typeof module === "undefined" ? "undefined" : _typeof(module)) === "object" && module && _typeof(module.exports) === "object" ? ENVIRONMENTS.NODE : ENVIRONMENTS.UNKNOWN;

var NetworkError =
/*#__PURE__*/
function (_Error) {
  _inherits(NetworkError, _Error);

  function NetworkError(message, response) {
    var _this;

    _classCallCheck(this, NetworkError);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(NetworkError).call(this, message));
    _this.name = _this.constructor.name;
    _this.response = response;
    _this.request = true;

    if (typeof Error.captureStackTrace === "function") {
      Error.captureStackTrace(_assertThisInitialized(_assertThisInitialized(_this)), _this.constructor);
    } else {
      _this.stack = new Error(message).stack;
    }

    return _this;
  }

  return NetworkError;
}(_wrapNativeSuper(Error));

function Regrest() {
  switch (ENV) {
    case ENVIRONMENTS.BROWSER:
      this.requestAdapter = browserRequest.bind(this);
      break;

    case ENVIRONMENTS.NODE:
      this.nodeAdapters = {
        http: require("follow-redirects").http,
        https: require("follow-redirects").https
      };
      this.requestAdapter = nodeRequest.bind(this);
      break;

    default:
      throw new Error("Unsupported environment");
  }
}
/**
 * @param {Config} config
 * @param {string} config.url - The url
 * @returns {Promise<Response>}
 * @memberof Regrest
 */


Regrest.prototype.request = function (_ref) {
  var _ref$method = _ref.method,
      method = _ref$method === void 0 ? "GET" : _ref$method,
      url = _ref.url,
      _ref$headers = _ref.headers,
      headers = _ref$headers === void 0 ? {} : _ref$headers,
      params = _ref.params,
      _ref$data = _ref.data,
      data = _ref$data === void 0 ? null : _ref$data,
      _ref$maxRedirects = _ref.maxRedirects,
      maxRedirects = _ref$maxRedirects === void 0 ? 5 : _ref$maxRedirects,
      _ref$withCredentials = _ref.withCredentials,
      withCredentials = _ref$withCredentials === void 0 ? false : _ref$withCredentials;
  // Generate query string and join it with url
  url = "".concat(url).concat(params ? "?".concat(Object.entries(params).map(function (_ref2) {
    var _ref3 = _slicedToArray(_ref2, 2),
        key = _ref3[0],
        value = _ref3[1];

    return "".concat(key, "=").concat(value);
  }).join("&")) : "");
  return this.requestAdapter(method, url, data, headers, maxRedirects, withCredentials);
}; // Convenience methods

/**
 * @param {string} url - The url
 * @param {Config} [config] - Config
 * @returns {Promise<Response>}
 * @memberof Regrest
 */


Regrest.prototype.get = function (url, config) {
  return this.request(_objectSpread({}, config, {
    url: url
  }));
};
/**
 * @param {string} url - The url
 * @param {Config} [config] - Config
 * @returns {Promise<Response>}
 * @memberof Regrest
 */


Regrest.prototype.head = function (url, config) {
  return this.request(_objectSpread({}, config, {
    method: "HEAD",
    url: url
  }));
};
/**
 * @param {string} url - The url
 * @param {*} [data] - The data to be sent
 * @param {Config} [config] - Config
 * @returns {Promise<Response>}
 * @memberof Regrest
 */


Regrest.prototype.post = function (url, data, config) {
  return this.request(_objectSpread({}, config, {
    method: "POST",
    url: url,
    data: data
  }));
};
/**
 * @param {string} url - The url
 * @param {*} [data] - The data to be sent
 * @param {Config} [config] - Config
 * @returns {Promise<Response>}
 * @memberof Regrest
 */


Regrest.prototype.put = function (url, data, config) {
  return this.request(_objectSpread({}, config, {
    method: "PUT",
    url: url,
    data: data
  }));
};
/**
 * @param {string} url - The url
 * @param {Config} [config] - Config
 * @returns {Promise<Response>}
 * @memberof Regrest
 */


Regrest.prototype.delete = function (url, config) {
  return this.request(_objectSpread({}, config, {
    method: "DELETE",
    url: url
  }));
};
/**
 * @param {string} url - The url
 * @param {Config} [config] - Config
 * @returns {Promise<Response>}
 * @memberof Regrest
 */


Regrest.prototype.options = function (url, config) {
  return this.request(_objectSpread({}, config, {
    method: "OPTIONS",
    url: url
  }));
};
/**
 * @param {string} url - The url
 * @param {*} [data] - The data to be sent
 * @param {Config} [config] - Config
 * @returns {Promise<Response>}
 * @memberof Regrest
 */


Regrest.prototype.patch = function (url, data, config) {
  return this.request(_objectSpread({}, config, {
    method: "PATCH",
    url: url,
    data: data
  }));
}; // Export


if ((typeof module === "undefined" ? "undefined" : _typeof(module)) === "object" && module && _typeof(module.exports) === "object") {
  /**
   * Expose Regrest as module.exports in loaders
   * that implement the Node module pattern (including browserify)
   */
  module.exports = new Regrest();
} else {
  // Otherwise expose Regrest to the global object
  window.regrest = new Regrest();
} // Unexposed helper methods and adapters


function browserRequest(requestType, url, body, headers, _, withCredentials) {
  return new Promise(function (resolve, reject) {
    var request = new XMLHttpRequest();
    request.open(requestType, url, true);
    Object.entries(headers).forEach(function (_ref4) {
      var _ref5 = _slicedToArray(_ref4, 2),
          key = _ref5[0],
          value = _ref5[1];

      return request.setRequestHeader(key, value);
    });
    withCredentials && (request.withCredentials = true);

    request.onload = function () {
      var response = {
        status: this.status,
        statusText: this.statusText,
        headers: _objectSpread({}, this.getAllResponseHeaders().trim().split(/[\r\n]+/).map(function (header) {
          return header.split(": ");
        }).reduce(function (obj, _ref6) {
          var _ref7 = _slicedToArray(_ref6, 2),
              key = _ref7[0],
              value = _ref7[1];

          return _objectSpread({}, obj, _defineProperty({}, key, value));
        }, {})),
        text: this.responseText,

        get json() {
          return JSON.parse(this.text);
        }

      };

      if (this.status >= 200 && this.status < 400) {
        resolve(response);
      } else {
        reject(new NetworkError("".concat(this.status, " ").concat(this.statusText), response));
      }
    };

    request.onerror = function () {
      reject(new NetworkError("connection error"));
    };

    request.send(body);
  });
}

function nodeRequest(requestType, url, body, headers, maxRedirects) {
  var _this2 = this;

  return new Promise(function (resolve, reject) {
    var parsedUrl = new URL(url);
    var options = {
      host: parsedUrl.host,
      path: "".concat(parsedUrl.pathname).concat(parsedUrl.search),
      method: requestType,
      headers: headers,
      maxRedirects: maxRedirects
    };

    var req = _this2.nodeAdapters[parsedUrl.protocol.slice(0, -1)].request(options, function (res) {
      var response = {
        status: res.statusCode,
        statusText: res.statusMessage,
        headers: res.headers,
        text: "",

        get json() {
          return JSON.parse(this.text);
        }

      };
      res.setEncoding("utf8");
      res.on("data", function (chunk) {
        return response.text += chunk;
      });
      res.on("end", function () {
        if (res.statusCode >= 200 && res.statusCode < 400) {
          resolve(response);
        } else {
          reject(new NetworkError("".concat(res.statusCode, " ").concat(res.statusMessage), response));
        }
      });
    });

    req.on("error", function (e) {
      return reject(new NetworkError(e));
    });
    body && req.write(body);
    req.end();
  });
}